(******************************************************************************
 *                                                                            *
 *                                                  *
 *                                                                            *
 *  :       main.pas                                                      *
 *  :       DirectX   *
 *                                                                            *
 ******************************************************************************)
unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls,
  ExtCtrls;

type
  TForm1 = class(TForm)
    gb1: TGroupBox;
    gb2: TGroupBox;
    gb3: TGroupBox;
    cbAdapter: TComboBox;
    cbSndCard: TComboBox;
    btnClose: TButton;
    cbInput: TComboBox;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    procedure btnCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  DirectDraw,
  DirectSound,
  DirectInput8;




//------------------------------------------------------------------------------
// :      DDEnumCallback()
// :     
//------------------------------------------------------------------------------
function DDEnumCallback( lpGuid: PGUID; lpstrDescription: PAnsiChar;
                         lpstrModule: PAnsiChar; lpContext: Pointer ): BOOL; stdcall;
var
  lpDD7: IDirectDraw7;
  dddi2: TDDDEVICEIDENTIFIER2;
begin
  //  ,   DDEnumCallback()    
  //   -     lpstrDescription
  // ( " ").    ,
  //    IDirectDraw7.GetDeviceIdentifier().   
  // DirectDraw   GUID ,   -
  //  lpGUID
  Result := FALSE;

  lpDD7 := nil;

  //   DirectDraw7,     GUID
  if FAILED( DirectDrawCreateEx( lpGUID, lpDD7, IID_IDirectDraw7,
                                 nil ) ) then
     Exit;
  lpDD7._AddRef();

  //    ,     dddi2
  lpDD7.GetDeviceIdentifier( dddi2, 0 );
  //       
  Form1.cbAdapter.Items.Add( dddi2.szDescription +
                             Format( ' ( %s)', [ dddi2.szDriver ] ) );
  //   DirectDraw7
  lpDD7._Release;
  lpDD7 := nil;

  Result := TRUE;
end;




//------------------------------------------------------------------------------
// :      DSEnumCallback()
// :     
//------------------------------------------------------------------------------
function DSEnumCallback( lpGuid: PGUID; lpstrDescription: PAnsiChar;
                         lpstrModule: PAnsiChar; lpContext: Pointer): BOOL; stdcall;
begin
  //  DSEnumCallback()       
  // 
  Form1.cbSndCard.Items.Add( lpstrDescription +
                             Format( ' (%s)', [ lpstrModule ] ) );
  Result := TRUE;
end;




//------------------------------------------------------------------------------
// :      DIEnumCallback()
// :     
//------------------------------------------------------------------------------
function DIEnumCallback( var lpddi: TDIDeviceInstanceA; pvRef: Pointer ):
  Integer; stdcall;
var
  desc: string;
begin
  //     .
  // :   DirectInput     
  //  , . .     .  
  // ""   ,    . ,
  //     DI8DEVTYPE_FLIGHT,    DI8DEVTYPE_GAMEPAD
  //     
  desc := ' ';
  case GET_DIDEVICE_TYPE( lpddi.dwDevType ) of
    DI8DEVTYPE_DEVICE:        desc := ' ';
    DI8DEVTYPE_MOUSE:         desc := '';
    DI8DEVTYPE_KEYBOARD:      desc := '';
    DI8DEVTYPE_JOYSTICK:      desc := '';
    DI8DEVTYPE_GAMEPAD:       desc := '';
    DI8DEVTYPE_DRIVING:       desc := '  ';          //?
    DI8DEVTYPE_FLIGHT:        desc := '';
    DI8DEVTYPE_1STPERSON:     desc := 'First-person action game device';  //?
    DI8DEVTYPE_DEVICECTRL:    desc := ' ';           //?
    DI8DEVTYPE_SCREENPointer: desc := ' ';
    DI8DEVTYPE_REMOTE:        desc := '  ';
    DI8DEVTYPE_SUPPLEMENTAL:  desc := '  ';
  end;   

  //       
  Form1.cbInput.Items.Add( lpddi.tszProductName + Format( ' (%s)', [ desc ] ) );

  Result := DIENUM_CONTINUE;
end;




//------------------------------------------------------------------------------
// :      TForm1.FormCreate()
// :     
//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
  lpDI8: IDirectInput8;
begin
  //   
  if FAILED( DirectDrawEnumerate( DDEnumCallback, nil) ) then
     Halt;

  //    
  if FAILED( DirectSoundEnumerate( DSEnumCallback, nil ) ) then
     Halt;

  //  DirectInputEnumerate()   ,  
  //     DirectInput8.EnumDevices()
  lpDI8 := nil;
  if FAILED( DirectInput8Create( GetModuleHandle( 0 ), DIRECTINPUT_VERSION,
                                 IID_IDirectInput8, lpDI8,  nil ) ) then
     Halt;
  lpDI8._AddRef;

  //     ,    .
  if FAILED( lpDI8.EnumDevices( DI8DEVCLASS_ALL, DIEnumCallback, nil,
                                DIEDFL_ALLDEVICES ) ) then
     Exit;

  //  
  lpDI8._Release();
  lpDI8 := nil;

  // GUI
  cbAdapter.ItemIndex := 0;
  cbSndCard.ItemIndex := 0;
  cbInput.ItemIndex   := 0;
end;




//------------------------------------------------------------------------------
// :      TForm1.Button1Click()
// :  
//------------------------------------------------------------------------------
procedure TForm1.btnCloseClick(Sender: TObject);
begin
  Form1.Close();
end;

end.
